#include "stroj_casu.h"

//#define S_DIRECT(x)		pole[i] = xmalloc(sizeof(x)); puts(pole[i]);  memcpy(pole[i], &(x), sizeof(x)); total_size += sizeof(x); sizes[i++] = sizeof(x)
#define S_INT(x)		fprintf(fp, "%d\n", x)
#define S_STR(x)		fprintf(fp, "%s\n", x)
#define S_CH_ARRAY(x,n)		for(int j=0;j<(n);j++) S_STR((x)[j])
#define S_BINARY(x)		fwrite((void *)(&(x)), sizeof(x), 1, fp); fputc(10,fp)

#define L_INT(x)		fscanf(fp, "%d", &(x))
#define L_STR(x)		do {					\
					char buf[LONG_STRING];		\
					fgets(buf, LONG_STRING, fp);		\
					if ((x) != NULL)		\
						xfree(x);		\
					x = xmalloc((strlen(buf) + 1) * sizeof(char));	\
					strcpy(x, buf);			\
				} while (0)
#define L_CH_ARRAY(x,n)		for(int j=0;j<(n);j++) L_STR((x)[j])
#define L_BINARY(x)		fread((void *)(&(x)), sizeof(x), 1, fp); fgetc(fp)

// Vsechno, co je potreba ulozit:
// int please_disgust;
// int commands_in_list;
// char commands_todo[][];
// int _plannedtasks_n;
// plannedtasks_t plannedtasks[];
// int _fortunefnames_n;
// char _fortunefnames[][];
// int mood;
// s64 stroj_offset;
// int languages;


void save_state(char * statefile)
{
	while (statefile[strlen(statefile)-1] < 26)  // removing trailing chars
		statefile[strlen(statefile)-1] = 0; 
	FILE * fp;
	fp = fopen(statefile, "w");
	S_INT(please_disgust);
	S_INT(commands_in_list);
	S_CH_ARRAY(commands_todo, commands_in_list);
	S_INT(_plannedtasks_n);
	S_BINARY(_plannedtasks);
	S_INT(_fortunefnames_n);
	S_CH_ARRAY(_fortunefnames, _fortunefnames_n);
	S_INT(mood);
	S_BINARY(stroj_offset);
	S_INT(languages);
	struct hw hardware;
	hardware = get_hw_state();
	S_BINARY(hardware);

	fclose(fp);
	
}

void load_state(char * statefile)
{
	// This function is intended for use only directly after the init
	// phase -- in some cases it causes memory leaks.
	// Don't try to parse any other file than the statefile as the
	// function doesn't do any validity-check
	while (statefile[strlen(statefile)-1] < 26)  // removing trailing chars
		statefile[strlen(statefile)-1] = 0; 
	FILE * fp;
	fp = fopen(statefile, "r");
	
	L_INT(please_disgust);
	L_INT(commands_in_list);
	L_CH_ARRAY(commands_todo, commands_in_list);
	L_INT(_plannedtasks_n);
	L_BINARY(_plannedtasks);
	L_INT(_fortunefnames_n);
	L_CH_ARRAY(_fortunefnames, _fortunefnames_n);
	L_INT(mood);
	L_BINARY(stroj_offset);
	L_INT(languages);
	// UNFINISHED
	struct hw hardware;
	L_BINARY(hardware);
	set_hw_state(hardware);

	fclose(fp);
}
